
#include "crc.h"
#include "crctable.h"

//------------------------------------------------------------------------
void update_crc(unsigned char num,unsigned char * CRCL,unsigned char * 
CRCH){
	unsigned int table_addr;
	table_addr=(num ^ *CRCH);
	*CRCH=(CRC_Table[table_addr] >> 8) ^ *CRCL;
	*CRCL=(CRC_Table[table_addr] & 0x00FF);
}
//------------------------------------------------------------------------
void reset_crc(unsigned char * CRCL,unsigned char * CRCH){
	*CRCL=0xFF;
	*CRCH=0xFF;
}

int validate_crc(unsigned char * input, unsigned char length, unsigned 
char * CRCL,unsigned char * CRCH)
{
	unsigned char calcH,calcL;
	reset_crc(&calcL,&calcH);
	int i;
	for (i = 0; i < length; i++)
	{
		update_crc(input[i],&calcL,&calcH);
	}
	if ((calcL == *CRCL) && (calcH == *CRCH))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int calc_crc(unsigned char * input, unsigned char length, unsigned char 
* CRCL,unsigned char * CRCH)
{
	
	reset_crc(CRCL,CRCH);
	int i;
	for (i = 0; i < length; i++)
	{
		update_crc(input[i],CRCL,CRCH);
	}
	return 1;
}
