#include <stdio.h>
#include "serialfunc.h"
#include "crc.h"
#include "ssp_private.h"
#include "ssp_defines.h"


int SendCommand(SSP_COMMAND c, int port);
int main(void)
{
	SSP_COMMAND test;
	int port = OpenPort("/dev/ttyUSB0");
	if (port == -1)
		return -1;
	SetupSSPPort(port);
	test.length = 1;
	//Send Sync Command
	test.data[0] = SSP_CMD_SYNC;
	test.address = 0;
	SendCommand(test,port);
	test.data[0] = SSP_CMD_RESET;
	//SendCommand(test,port);
	ClosePort(port);
}

unsigned char GetSeqByte(const char cmd)
{
	static unsigned char seq = 0;
	if (cmd == SSP_CMD_SYNC)
	{
		//force seq to 0x80 if command is SSP_SYNC
		seq = 0x80;
	}
	else
	{	
		//rotate the seq byte between 0 and 0x80
		if (seq != 0)
			seq = 0;
		else
			seq = 0x80;
	}
	return seq;
}

int SendCommand(SSP_COMMAND c, int port)
{
	unsigned long i;
	unsigned long data_length;
	unsigned char data[MAX_CMD_LEN];
	unsigned long bib;
	data[SSP_STX_POS] = SSP_STX_BYTE;
	data[SSP_SEQ_POS] = GetSeqByte(c.data[0] | c.address & 0x7F);
	data[SSP_LEN_POS] = c.length ;
	for (i = 0; i < c.length; ++i)
		data[SSP_LEN_POS + 1 + i] = c.data[i];
	calc_crc(&data[1],c.length + 2, &data[c.length+3], &data[c.length+4]);
	data_length = c.length + 5;
	for (i = 0; i < data_length ; ++i)
	{
		if (i > 0)
		{	
			//Byte Stuff
			if (data[i] == SSP_STX_BYTE)
				WriteData(&data[i],1,port);
		}	
		WriteData(&data[i],1,port);
	}
	sleep(1);	
	printf("----\n");
	printf("Recieved\n");
	printf("----\n");
	bib = BytesInBuffer(port);	
	if (bib > 0)
	{
		ReadData(port,data,bib+1);
		for (i = 0; i < bib; ++i)		
			printf("%x\n",data[i]);
	}
}
